#define XMD_H 1
#define IMPORTJPGDLL 1

#include <stdio.h>
#include <windows.h>
#include <GL/glut.h>


//#include <wingdi.h>
#include "ijl.h"


#pragma comment(lib, "ijl15.lib")
#pragma comment(lib, "glut32.lib")


void init();

int screenWidth=800, screenHeight=600;

int quality=85;


struct BMP24
{
	BITMAPINFOHEADER bitmapInfo;
	BITMAPFILEHEADER bitmapFileHeader; 
	unsigned char * bitmapImage;
	char inputFileName[MAX_PATH*4];
	char outputFileName[MAX_PATH*4];
	char currentPath[MAX_PATH*4];
	int width, height;
	int paddedWidth;

	bool loadFile(char* fileName);
	void shrink(int newWidth, int newHeight);

	void shrinkRow(int r, int newWidth);
	void shrinkCol(int c, int newHeight);

	void enlarge(int newWidth, int newHeight);
	void enlargeRow(int r, int newWidth, unsigned char*newImage, int newPaddedWidth);
	void enlargeCol(int c, int newHeight, unsigned char*newImage, int newPaddedWidth);

	void resize(int newWidth, int newHeight);
	void saveFile(char* fileName);

	void reload();
	void resave();
	BMP24();
	~BMP24();
};

struct JPG24
{
	int width;
	int height;
	bool readyDisplay;
	unsigned char* pixels;
};


JPG24 jpg;


void getLastError()
{
	GLenum err;
	char msg[256];
	err=glGetError();
	switch(err)
	{
	case GL_NO_ERROR:
		sprintf(msg, "GL_NO_ERROR");
		break;
	case GL_INVALID_ENUM:
		sprintf(msg, "GL_INVALID_ENUM");
		break;
	case GL_INVALID_VALUE:
		sprintf(msg, "GL_INVALID_VALUE");
		break;
	case GL_INVALID_OPERATION:
		sprintf(msg, "GL_INVALID_OPERATION");
		break;
	case GL_STACK_OVERFLOW:
		sprintf(msg, "GL_STACK_OVERFLOW");
		break;
	case GL_STACK_UNDERFLOW:
		sprintf(msg, "GL_STACK_UNDERFLOW");
		break;
	case GL_OUT_OF_MEMORY:
		sprintf(msg, "GL_OUT_OF_MEMORY");
		break;
	}
	if (err!=GL_NO_ERROR)
	{
		printf("error message %s\n", msg);
		exit(err);
	}
}

bool loadJpeg(char* fileName, JPG24& jpg24);


typedef void (*CallbackFunc)(char* fileName);


void GenericRetrieveAllFile(char* dir, CallbackFunc callback)
{
	HANDLE handle;	
	char curFileName[2048];
	char wildFileName[2048];
	
	WIN32_FIND_DATA ffd;
	
	sprintf(wildFileName, "%s\\*.*", dir);
	handle=FindFirstFile(wildFileName, &ffd);
	
	if (handle==INVALID_HANDLE_VALUE)
	{
		printf("findfirst failed of %s error code =%d\n", dir, GetLastError());
		exit(19);
	}

	while (FindNextFile(handle, &ffd))
	{		
		if (strcmp(ffd.cFileName, "..")!=0)
		{
			sprintf(curFileName, "%s\\%s", dir, ffd.cFileName);
			if  (GetFileAttributes(curFileName)&FILE_ATTRIBUTE_DIRECTORY)
			{
				GenericRetrieveAllFile(curFileName, callback);
			}
			else
			{
				callback(curFileName);
			}
		}			
	}
	FindClose(handle);
}

/*
void JPG::loadJPG()
{
	OPENFILENAME op;
	char filterStr[256]={"jpeg file\0 *.jpg\0  \0\0"};
	
	memset(&op, 0, sizeof(OPENFILENAME));
	GetCurrentDirectory(256, bmp.currentPath+4);
	op.lStructSize=sizeof(OPENFILENAME);
	op.hInstance=NULL;
	op.hwndOwner=NULL;
	op.lpstrCustomFilter=NULL;
	//op.lpstrFilter=NULL;
	//strcpy(buffer, "myoutput.bmp");
	op.lpstrFile=inputFileName;
	//op.lpstrFile=buffer;
	op.nMaxFile=MAX_PATH;
	op.lpstrFileTitle=NULL;
	op.lpstrInitialDir=NULL;
	op.lpstrTitle=NULL;
	op.lpstrDefExt=NULL;
	op.lpstrInitialDir=bmp.currentPath;
	op.lpstrFilter=filterStr;
	op.Flags=OFN_FILEMUSTEXIST;
	if (GetOpenFileName(&op))
	{		
		if (bmp.inputFileName[0]!='\0')
		{
			DeleteFile(bmp.inputFileName);
		}
		GetTempFileName(bmp.currentPath, "bmp", 0, bmp.inputFileName);	
		deCompressJPG(inputFileName, bmp.inputFileName, FMT_BMP);
		bmp.reload();
		readyDisplay=true;
		init();
	}	
}

void JPG::saveJPG()
{
	OPENFILENAME op;
	char filterStr[256]={"jpeg file\0 *.jpg\0  \0\0"};
	memset(&op, 0, sizeof(OPENFILENAME));
	
	GetCurrentDirectory(MAX_PATH, bmp.currentPath+4);
	op.lStructSize=sizeof(OPENFILENAME);
	op.hInstance=NULL;
	op.hwndOwner=NULL;
	op.lpstrCustomFilter=NULL;
	//op.lpstrFilter=NULL;
	//strcpy(buffer, "myoutput.bmp");
	//strcpy(bmp.outputFileName, bmp.inputFileName);
	op.lpstrFile=outputFileName;
	//op.lpstrFile=buffer;
	op.nMaxFile=MAX_PATH;
	op.lpstrFileTitle=NULL;
	op.lpstrInitialDir=NULL;
	op.lpstrTitle=NULL;
	op.lpstrDefExt=NULL;
	op.lpstrFilter=filterStr;

	op.lpstrInitialDir=bmp.currentPath;
	
	op.Flags=OFN_OVERWRITEPROMPT;
	if (GetSaveFileName(&op))
	{		
		strcat(outputFileName, ".jpg");	
		if (bmp.inputFileName[0]!='\0')
		{
			if (!DeleteFile(bmp.inputFileName))
			{
				printf("delete file failed %d\n", GetLastError());
			}
		}
		//GetTempFileName(".", "bmp", 0, bmp.outputFileName);
		GetTempFileName(bmp.currentPath, "bmp", 0, bmp.outputFileName);	
		bmp.resave();
		compressJPG(bmp.outputFileName, outputFileName, quality);
		delete[]bmp.bitmapImage;
		bmp.bitmapImage=NULL;
		DeleteFile(bmp.inputFileName);
		DeleteFile(bmp.outputFileName);
		bmp.inputFileName[0]='\0';
		bmp.outputFileName[0]='\0';
		readyDisplay=false;
	}
}


BMP24::BMP24()
{
	bitmapImage=NULL;
	inputFileName[0]='\0';
	outputFileName[0]='\0';
	strcpy(currentPath, "\\\\?\\");
	GetCurrentDirectory(MAX_PATH, currentPath+4);
}

BMP24::~BMP24()
{
	if (bitmapImage!=NULL)
	{
		delete[]bitmapImage;
	}
	if (inputFileName[0]!='\0')
	{
		DeleteFile(inputFileName);
	}
	if (outputFileName[0]!='\0')
	{
		DeleteFile(outputFileName);
	}
}

void BMP24::shrinkRow(int r, int newWidth)
{
	int red, green, blue;
	int stride=width/newWidth;
	int index;
	
	for (int c=0; c<newWidth; c++)
	{
		red=green=blue=0;
		for (int x=0; x<stride; x++)
		{
			//it never exceeds boundary	
			//read from old buffer
			index=r*paddedWidth+(x+c*width/newWidth)*3;
			blue+=bitmapImage[index];
			green+=bitmapImage[index+1];
			red+=bitmapImage[index+2];
		}			
		index=r*paddedWidth+c*3;

		bitmapImage[index]=blue/stride;
		bitmapImage[index+1]=green/stride;
		bitmapImage[index+2]=red/stride;
	}
}

void BMP24::shrinkCol(int c, int newHeight)
{
	int red=0, green=0, blue=0;
	int stride=height/newHeight;
	int index;
	
	for (int r=0; r<newHeight; r++)
	{
		red=green=blue=0;
		for (int y=0; y<stride; y++)
		{
			//it never exceeds boundary		
			index=(r*height/newHeight+y)*paddedWidth+ c*3;
			blue+=bitmapImage[index];
			green+=bitmapImage[index+1];
			red+=bitmapImage[index+2];
		}	
		index=r*paddedWidth+c*3;

		bitmapImage[index]=blue/stride;
		bitmapImage[index+1]=green/stride;
		bitmapImage[index+2]=red/stride;
	}
}


void BMP24::shrink(int newWidth, int newHeight)
{
	unsigned char* newImage;
	int newPaddedWidth;
	newPaddedWidth=(newWidth*3+3)/4*4;
	newImage=new unsigned char[newPaddedWidth*newHeight];
	if (newWidth<width)
	{
		for (int r=0; r<newHeight; r++)
		{
			shrinkRow(r, newWidth);	
		}
	}
	if (newHeight<height)
	{

		for (int c=0; c<newWidth; c++)
		{
			shrinkCol(c, newHeight);		
		}
	}
	//new let's write result to new buffer
	for (int i=0; i<newHeight; i++)
	{
		memcpy(newImage+i*newPaddedWidth, bitmapImage+i*paddedWidth, newWidth*3);
		memset(newImage+i*newPaddedWidth+newWidth*3, 0, newPaddedWidth-newWidth*3);
	}
	delete[]bitmapImage;
	bitmapImage=newImage;
	width=newWidth;
	height=newHeight;
	paddedWidth=newPaddedWidth;
}


//please note that we have to copy data from new Image cause old image is narrow
//and we have to do it from high to low
void BMP24::enlargeCol(int c, int newHeight, unsigned char*newImage, int newPaddedWidth)
{
	int stride=newHeight/height;
	int oldIndex, newIndex;
	
	for (int r=newHeight-2; r>=0; r--)
	{
		for (int y=0; y<stride; y++)
		{
			//it never exceeds boundary	
			//read from old buffer
			newIndex=(r+y)*newPaddedWidth+ c*3;
			oldIndex=r*height/newHeight*newPaddedWidth+ c*3;
			memcpy(newImage+newIndex, newImage+oldIndex, 3);			
		}	
	}
}

void BMP24::enlargeRow(int r, int newWidth, unsigned char*newImage, int newPaddedWidth)
{
	int stride=newWidth/width;
	int oldIndex, newIndex;
	
	for (int c=0; c<newWidth; c++)
	{
		for (int x=0; x<stride; x++)
		{
			//it never exceeds boundary	
			//read from old buffer
			newIndex=r*newPaddedWidth+(x+c)*3;
			oldIndex=r*paddedWidth+ c*width/newWidth*3;
			memcpy(newImage+newIndex, bitmapImage+oldIndex, 3);			
		}	
	}
}


void BMP24::enlarge(int newWidth, int newHeight)
{
	unsigned char* newImage;
	int newPaddedWidth;
	newPaddedWidth=(newWidth*3+3)/4*4;
	newImage=new unsigned char[newPaddedWidth*newHeight];
	memset(newImage, 0, newPaddedWidth*newHeight);

	if (newWidth>width)
	{
		for (int r=0; r<height; r++)
		{
			enlargeRow(r, newWidth, newImage, newPaddedWidth);	
		}
	}
	else
	{
		//newWidth==width
		for (int i=0; i<height; i++)
		{
			memcpy(newImage+i*newPaddedWidth, bitmapImage+i*paddedWidth, width*3);
		}
	}

	if (newHeight>height)
	{
		for (int c=0; c<newWidth; c++)
		{
			enlargeCol(c, newHeight, newImage, newPaddedWidth);		
		}
	}

	delete[]bitmapImage;
	bitmapImage=newImage;
	width=newWidth;
	height=newHeight;
	paddedWidth=newPaddedWidth;
}

void BMP24::resize(int newWidth, int newHeight)
{
	if (newWidth>width)
	{
		enlarge(newWidth, height);
	}
	else
	{
		if (newWidth<width)
		{
			shrink(newWidth, height);
		}
	}
	if (newHeight>height)
	{
		enlarge(width, newHeight);
	}
	else
	{
		if (newHeight<height)
		{
			shrink(width, newHeight);
		}
	}
}

void BMP24::saveFile(char* fileName)
{
	FILE *filePtr; //our file pointer
	
	strcpy(outputFileName, fileName);
	if (strcmp(inputFileName, outputFileName)==0)
	{
		if (MessageBoxEx(NULL, "Do you want to overwrite original file?", 
			"save file with same name will destory original file", MB_OKCANCEL,
			MAKELANGID(LANG_CHINESE, SUBLANG_ENGLISH_CAN))==IDCANCEL)
		{
			return;
		}
	}
	//open filename in read binary mode
	if ((filePtr = fopen(fileName,"wb"))==NULL)
	{
		return ;
	}
	//read the bitmap file header

	//bitmapFileHeader.bfOffBits=sizeof(BITMAPFILEHEADER)+sizeof(BITMAPINFOHEADER);	
	bitmapFileHeader.bfSize=bitmapFileHeader.bfOffBits+paddedWidth*height;
	
	//bitmapFileHeader.bfType=0x4D42;
	//bitmapFileHeader.bfReserved1=bitmapFileHeader.bfReserved2=0;

	fwrite(&bitmapFileHeader, sizeof(BITMAPFILEHEADER), 1, filePtr);

	bitmapInfo.biWidth=width;
	bitmapInfo.biHeight=height;

	fwrite(&bitmapInfo, sizeof(BITMAPINFOHEADER), 1, filePtr);

	fseek(filePtr, bitmapFileHeader.bfOffBits, SEEK_SET);
	//read the bitmap info header
	fwrite(bitmapImage, paddedWidth*height, 1, filePtr);

	fclose(filePtr);
}

void BMP24::reload()
{
	loadFile(inputFileName);
}

void BMP24::resave()
{
	saveFile(outputFileName);
}

bool BMP24::loadFile(char* fileName)
{
	FILE *filePtr; //our file pointer
	
	strcpy(inputFileName, fileName);

	//open filename in read binary mode
	if ((filePtr = fopen(fileName,"rb"))==NULL)
	{
		return false;
	}
	//read the bitmap file header
	fread(&bitmapFileHeader, sizeof(BITMAPFILEHEADER), 1, filePtr);

	//verify that this is a bmp file by check bitmap id
	if (bitmapFileHeader.bfType !=0x4D42)
	{
		fclose(filePtr);
		return false;
	}

	//read the bitmap info header
	fread(&bitmapInfo, sizeof(BITMAPINFOHEADER), 1, filePtr);


	width=bitmapInfo.biWidth;
	height=bitmapInfo.biHeight;
	paddedWidth=(width*3+3)/4*4;

	if (bitmapInfo.biBitCount!=24)
	{
		printf("your file is not 24 bit bitmap. \n");
		fclose(filePtr);
		return false;
	}

	if  (bitmapInfo.biCompression!= BI_RGB)
	{
		printf("color format is not RGB\n");
		fclose(filePtr);
		return false;
	}

	bitmapImage=new unsigned char[paddedWidth*height];

	fseek(filePtr, bitmapFileHeader.bfOffBits, SEEK_SET);

	fread(bitmapImage, paddedWidth*height, 1, filePtr);

	
	fclose(filePtr);
	return true;
}

void reloadJPG()
{
	if (jpg.readyDisplay)
	{
		jpg.bmp.reload();
		glutReshapeWindow(jpg.bmp.width, jpg.bmp.height);
	}	
}

void loadJPG()
{
	jpg.loadJPG();
	screenWidth=jpg.bmp.width;
	screenHeight=jpg.bmp.height;
}

void saveJPG()
{
	delete[] jpg.bmp.bitmapImage;
	jpg.bmp.paddedWidth=(screenWidth*3+3)/4*4;

	jpg.bmp.bitmapImage=new unsigned char[jpg.bmp.paddedWidth*screenHeight];
	glReadPixels(0, 0, screenWidth, screenHeight, GL_BGR, GL_UNSIGNED_BYTE, 
		jpg.bmp.bitmapImage);
	jpg.bmp.width=screenWidth;
	jpg.bmp.height=screenHeight;

	jpg.saveJPG();		
}
*/

void init()
{
	if (!loadJpeg("mytest.jpg", jpg))
	{
		MessageBox(NULL, "failed loading", "title", MB_OK);
		exit(1);
	}
	jpg.readyDisplay=true;

	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	if (jpg.readyDisplay)
	{
		glOrtho(0, -jpg.width, 0, -jpg.height, 0, 100);
		getLastError();
		glutReshapeWindow(jpg.width, jpg.height);
	}
	else
	{
		glOrtho(0, 800, 0, 600, 0, 100);
		glutReshapeWindow(800, 600);
	}
}

void displayString(int x, int y, char* str)
{
	char*ptr=str;
	glColor3f(1.0, 0, 0);
	glRasterPos2f(x, y);
	while (*ptr!='\0')
	{
		glutBitmapCharacter(GLUT_BITMAP_TIMES_ROMAN_24, *ptr);
		ptr++;
	}
}

void showMenu()
{
	char buf[256];
	displayString(50, screenHeight-150, "this program helps you to adjust jpeg file size");
	displayString(50, screenHeight-165, "to ajust picture size, use your mouse");
	displayString(50, screenHeight-200, "press 'o' to load jpeg file to edit");
	displayString(50, screenHeight-250, "press 's' to save edited jpeg file");
	displayString(50, screenHeight-300, "press 'esc' to exit program");
	displayString(50, screenHeight-350, "click mouse right button for menu");
	displayString(50, screenHeight-400, "to ajust jpeg quality use '+' and '-'");
	sprintf(buf, "current quality setting is %d", quality);
	displayString(50, screenHeight-450, buf);

	displayString(50, screenHeight-500, "to give up your edit and reload original file press 'r'");

}

void menuFunc(int menu)
{
	switch (menu)
	{
	case 0:
		//loadJPG();
		break;
	case 1:
		//saveJPG();
		break;
	case 2:
		//reloadJPG();
		break;
	}
	glutPostRedisplay();
}

void initMenu()
{
	glutCreateMenu(menuFunc);
	glutAddMenuEntry("load jpeg file", 0);
	glutAddMenuEntry("save jpeg file", 1);
	glutAddMenuEntry("reload jpeg file", 2);
	glutAttachMenu(GLUT_RIGHT_BUTTON);

}


void display()
{
	glClearColor(255,255,255,255);
	glClear(GL_COLOR_BUFFER_BIT);

	//init();
	glRasterPos2f(0,0);

	glPixelStorei(GL_UNPACK_ALIGNMENT, 4);

	if (jpg.readyDisplay)
	{
		glDrawPixels(jpg.width, jpg.height,	GL_BGR, GL_UNSIGNED_BYTE, 
			jpg.pixels);
	}
	else
	{
		showMenu();
	}

	glutSwapBuffers();
}

void reshape(int newWidth, int newHeight)
{
	/*
	if (jpg.readyDisplay)
	{
		jpg.bmp.resize(newWidth, newHeight);
	}
	*/
	screenWidth=newWidth;
	screenHeight=newHeight;
	
	glPixelZoom((GLfloat)(newWidth)/(GLfloat)(jpg.width), 
		(GLfloat)(newHeight)/(GLfloat)(jpg.height));
	
	glutPostRedisplay();
}



void keyboard(unsigned char key, int x, int y)
{
	switch (key)
	{
	case 27:
		exit(0);
	case 'r':
		//reloadJPG();		
		break;
	case 's':
	case 'S':
		//saveJPG();
		break;
	case 'o':
	case 'O':
		//loadJPG();		
		break;
	case '+':
		if (quality<100)
		{
			quality++;
		}		
		break;
	case '-':
		if (quality>1)
		{
			quality--;
		}
		break;
	}
	glutPostRedisplay();
}

int main(int argc, char** argv)
{
	glutInit(&argc, argv);

	glutInitDisplayMode(GLUT_DOUBLE|GLUT_RGBA|GLUT_ALPHA);

	glutInitWindowPosition(0,0);
	glutInitWindowSize(600, 800);
	glutCreateWindow("my test");

	glutDisplayFunc(display);
	glutReshapeFunc(reshape);

	glutKeyboardFunc(keyboard);


	init();

	initMenu();

	glutMainLoop();
	return 0;
}



bool loadJpeg(char* fileName, JPG24& jpg24)
{
	 //Error handle
	IJLERR jerr;

	//Create the JPEG object
	JPEG_CORE_PROPERTIES jcprops;

	//Initialize the JPEG object
	jerr = ijlInit(&jcprops);
	if (jerr != IJL_OK)
	{
		MessageBox(NULL, "IJLInit problem", "init failed", MB_OK);
		return false;
	}


		//Set the IJL data source as a filename
	jcprops.JPGFile = fileName;

	//Read JPEG parameters from the file
	jerr = ijlRead(&jcprops, IJL_JFILE_READPARAMS);




	//Make sure Parameter read was successful
	if (jerr != IJL_OK)
	{
	  MessageBox(NULL, "Error reading JPEG parameters", "my box", MB_OK);
	  return false;
	}
	jpg.width=jcprops.JPGWidth;
	jpg.height=jcprops.JPGHeight;


	//Determine the required size
	long szbuff24 = (jcprops.JPGWidth * 24 + 7) / 8
	  * jcprops.JPGHeight;

	//Resize the buffer
	jpg24.pixels = new BYTE [szbuff24];
	if (jpg24.pixels == NULL)
	{
		MessageBox(NULL, "Memory Allocation Error", "my box", MB_OK);
		return false;
	}

	//Set up the DIB specification for the JPEG decoder
	jcprops.DIBWidth    = jcprops.JPGWidth;
	jcprops.DIBHeight   = jcprops.JPGHeight; //Implies a bottom-up DIB.
	jcprops.DIBChannels = 3;
	jcprops.DIBColor    = IJL_BGR;
	jcprops.DIBPadBytes = IJL_DIB_PAD_BYTES(jcprops.JPGWidth,3);
	jcprops.DIBBytes    = reinterpret_cast<BYTE*>(jpg24.pixels);

	//Set the JPG color space ... this will always be somewhat of an
	//educated guess at best because JPEG is "color blind" (i.e.,
	//nothing in the bit stream tells you what color space the data was
	//encoded from. However, in this example we assume that we are
	//reading JFIF files which means that 3 channel images are in the
	//YCbCr color space and 1 channel images are in the Y color space.
	switch(jcprops.JPGChannels)
	{
	  case 1: jcprops.JPGColor = IJL_G;
		 break;
  
	  case 3: jcprops.JPGColor = IJL_YCBCR;
		 break;
  
	  default:
		 //This catches everything else, but no color twist will be
		 //performed by the IJL.
		 jcprops.DIBColor = (IJL_COLOR)IJL_OTHER;
		 jcprops.JPGColor = (IJL_COLOR)IJL_OTHER;
		 break;
	}
   
  
	jerr = ijlRead(&jcprops, IJL_JFILE_READWHOLEIMAGE);
  

	//Make sure the read was successful
	if (jerr != IJL_OK)
	{
		MessageBox(NULL, "Error reading JPEG image", "my box", MB_OK);
		return false;
	}
	return true;
}